%This M-Function was created automatically by PSG Toolbox.
%See section "Special Subroutines in Toolbox -> User Subroutine in Toolbox" in PSG Help Manual.
%
%Input variables:
%
%Inputs                        PSG Type    PSG Object               Location in Problem Statement                                                Class
%matrix_f3_benchmark           bench       matrix_f3                n/a                                                                          double
%matrix_f3_data                data        matrix_f3                n/a                                                                          double
%matrix_f3_vars                vars        matrix_f3                n/a                                                                          cell
%matrix_f3_with_label0_data    data        matrix_f3_with_label0    n/a                                                                          double
%matrix_f3_with_label0_vars    vars        matrix_f3_with_label0    n/a                                                                          cell
%matrix_f3_with_label1_data    data        matrix_f3_with_label1    n/a                                                                          double
%matrix_f3_with_label1_vars    vars        matrix_f3_with_label1    n/a                                                                          cell
%parameter_precision_data      data        parameter_precision      Solver: precision = parameter_precision                                      char
%parameter_alpha_data          data        parameter_alpha          pr_pen(parameter_alpha,L(matrix_F3_with_label1)-L(matrix_F3_with_label0))    double
%
%Output variables:
%
%solution_str = string with solution of problem;
%outargstruc_arr = array of output PSG data structures;


function [solution_str,outargstruc_arr] = Optimization_subroutine(matrix_f3_benchmark,matrix_f3_data,matrix_f3_vars,matrix_f3_with_label0_data,matrix_f3_with_label0_vars,matrix_f3_with_label1_data,matrix_f3_with_label1_vars,parameter_precision_data,parameter_alpha_data)

%Pack data to PSG structure:
count = 0;
count = count+1;
iargstruc_arr(count) = matrix_pack('matrix_f3',matrix_f3_data,matrix_f3_vars,matrix_f3_benchmark,[]);
count = count+1;
iargstruc_arr(count) = matrix_pack('matrix_f3_with_label0',matrix_f3_with_label0_data,matrix_f3_with_label0_vars,[],[]);
count = count+1;
iargstruc_arr(count) = matrix_pack('matrix_f3_with_label1',matrix_f3_with_label1_data,matrix_f3_with_label1_vars,[],[]);
%Define problem statement:
problem_statement = sprintf('%s\n',...
'maximize                         ',...
'                            ',...
'  logexp_sum(matrix_F3)',...
'                                      ',...
'Solver: precision = parameter_precision           ',...
'                             ',...
'Value:                           ',...
'                            ',...
'  pr_pen(parameter_alpha,L(matrix_F3_with_label1)-L(matrix_F3_with_label0))',...
'',...
'                                                              ',...
' ');
%Change parameters with their values in problem statement:
problem_statement = strrep(problem_statement,'parameter_precision',parameter_precision_data);
problem_statement = strrep(problem_statement,'parameter_alpha',num2str(parameter_alpha_data));

%Optimize problem using mpsg_solver function:
[solution_str, outargstruc_arr] = mpsg_solver(problem_statement, iargstruc_arr);
results = psg_convert_outargstruc(solution_str,outargstruc_arr);
outargstruc_arr = results.data;
solution_str = results.string;

%=======================================================================|
%American Optimal Decisions, Inc. Copyright                             |
%Copyright American Optimal Decisions, Inc. 2007-2016.                 |
%American Optimal Decisions (AOD) retains copyrights to this material.  |
%                                                                       |
%Permission to reproduce this document and to prepare derivative works  |
%from this document for internal use is granted, provided the copyright |
%and No Warranty  statements are included with all reproductions       |
%and derivative works.                                                  |
%                                                                       |
%For information regarding external or commercial use of copyrighted    |
%materials owned by AOD, contact AOD at support@aorda.com.              |
%=======================================================================|
 

